#include "spi.h"

//SPIڳʼ
//ǶSPI1ĳʼ
void SPI1_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    SPI_InitTypeDef  SPI_InitStructure;

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA|RCC_APB2Periph_SPI1, ENABLE );

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_SetBits(GPIOA,GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7);

    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;   //SPI˫ģʽ:SPIΪ˫˫ȫ˫
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;       //SPIģʽ:ΪSPI
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;   //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_High; //ѡ˴ʱӵ̬:ʱո
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;//ݲڵڶʱ
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;   //NSSźӲNSSܽţʹSSIλ:ڲNSSźSSIλ
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256; //岨ԤƵֵ:ԤƵֵΪ256
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;  //ָݴMSBλLSBλʼ:ݴMSBλʼ
    SPI_InitStructure.SPI_CRCPolynomial = 7;    //CRCֵĶʽ
    SPI_Init(SPI1, &SPI_InitStructure);         //SPI_InitStructָĲʼSPIxĴ

    SPI_Cmd(SPI1, ENABLE);   //ʹSPI

    SPI1_ReadWriteByte(0xff);//
}


//SPIx дһֽ
//TxData:Ҫдֽ
//ֵ:ȡֽ
u8 SPI1_ReadWriteByte(u8 TxData)
{
    u8 retry=0;
    while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET) //ָSPI־λ:ͻձ־λ
        {
        retry++;
        if(retry>200)return 0;
        }
    SPI_I2S_SendData(SPI1, TxData);   //ͨSPIxһ
    retry=0;

    while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET)//ָSPI־λ:ܻǿձ־λ
        {
        retry++;
        if(retry>200)return 0;
        }
    return SPI_I2S_ReceiveData(SPI1); //ͨSPIxյ
}































